std::allocator_traits< _Alloc >(3)

NAME
std::allocator_traits< _Alloc > -

SYNOPSIS

Inherited by __gnu_cxx::__alloc_traits< _Alloc >.

  Public Types
typedef _Alloc allocator_type
typedef __const_pointer const_pointer
typedef __const_void_pointer const_void_pointer
typedef __difference_type difference_type
typedef __pointer pointer
typedef __propagate_on_container_copy_assignment propagate_on_container_copy_assignment
typedef __propagate_on_container_move_assignment propagate_on_container_move_assignment
typedef __propagate_on_container_swap propagate_on_container_swap
template<typename _Tp > using rebind_alloc = typename __alloctr_rebind< _Alloc, _Tp >::__type
template<typename _Tp > using rebind_traits = allocator_traits< rebind_alloc< _Tp >>
typedef __size_type size_type
typedef _Alloc::value_type value_type
typedef __void_pointer void_pointer

  Static Public Member Functions
static pointer allocate (_Alloc &__a, size_type __n)
static pointer allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
template<typename _Tp , typename... _Args> static auto construct (_Alloc &__a, _Tp *__p, _Args &&...__args) -> decltype(_S_construct(__a, __p, std::forward< _Args >(__args)...))
static void deallocate (_Alloc &__a, pointer __p, size_type __n)
template<class _Tp > static void destroy (_Alloc &__a, _Tp *__p)
static size_type max_size (const _Alloc &__a) noexcept
static _Alloc select_on_container_copy_construction (const _Alloc &__rhs)

Detailed Description

  template<typename _Alloc>struct std::allocator_traits< _Alloc >
Uniform interface to all allocator types.

Definition at line 83 of file bits/alloc_traits.h.

Member Typedef Documentation

  template<typename _Alloc> typedef _Alloc std::allocator_traits< _Alloc >::allocator_type

The allocator type.

Definition at line 86 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __const_pointer std::allocator_traits< _Alloc >::const_pointer

The allocator's const pointer type. Alloc::const_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<const value_type>

Definition at line 116 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __const_void_pointer std::allocator_traits< _Alloc >::const_void_pointer

The allocator's const void pointer type. Alloc::const_void_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<const void>

Definition at line 138 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __difference_type std::allocator_traits< _Alloc >::difference_type

The allocator's difference type. Alloc::difference_type if that type exists, otherwise pointer_traits<pointer>::difference_type

Definition at line 149 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __pointer std::allocator_traits< _Alloc >::pointer

The allocator's pointer type. Alloc::pointer if that type exists, otherwise value_type*

Definition at line 105 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __propagate_on_container_copy_assignment std::allocator_traits< _Alloc >::propagate_on_container_copy_assignment

How the allocator is propagated on copy assignment. Alloc::propagate_on_container_copy_assignment if that type exists, otherwise false_type

Definition at line 172 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __propagate_on_container_move_assignment std::allocator_traits< _Alloc >::propagate_on_container_move_assignment

How the allocator is propagated on move assignment. Alloc::propagate_on_container_move_assignment if that type exists, otherwise false_type

Definition at line 184 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __propagate_on_container_swap std::allocator_traits< _Alloc >::propagate_on_container_swap

How the allocator is propagated on swap. Alloc::propagate_on_container_swap if that type exists, otherwise false_type

Definition at line 195 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __size_type std::allocator_traits< _Alloc >::size_type

The allocator's size type. Alloc::size_type if that type exists, otherwise make_unsigned<difference_type>::type

Definition at line 160 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef _Alloc::value_type std::allocator_traits< _Alloc >::value_type

The allocated type.

Definition at line 88 of file bits/alloc_traits.h.

  template<typename _Alloc> typedef __void_pointer std::allocator_traits< _Alloc >::void_pointer

The allocator's void pointer type. Alloc::void_pointer if that type exists, otherwise pointer_traits<pointer>::rebind<void>

Definition at line 127 of file bits/alloc_traits.h.

Member Function Documentation

  template<typename _Alloc> static pointer std::allocator_traits< _Alloc >::allocate (_Alloc & __a, size_type __n) [inline], [static]

Allocate memory.

Parameters:
    __a An allocator.
    __n The number of objects to allocate space for.

Calls a.allocate(n)

Definition at line 359 of file bits/alloc_traits.h.

Referenced by std::__allocate_guarded().

  template<typename _Alloc> static pointer std::allocator_traits< _Alloc >::allocate (_Alloc & __a, size_type __n, const_void_pointer __hint) [inline], [static]

Allocate memory.

Parameters:
    __a An allocator.
    __n The number of objects to allocate space for.
    __hint Aid to locality.

Returns:
    Memory of suitable size and alignment for n objects of type value_type

Returns a.allocate(n, hint) if that expression is well-formed, otherwise returns a.allocate(n)

Definition at line 374 of file bits/alloc_traits.h.

  template<typename _Alloc> template<typename _Tp , typename... _Args> static auto std::allocator_traits< _Alloc >::construct (_Alloc & __a, _Tp * __p, _Args &&... __args) -> decltype(_S_construct(__a, __p, std::forward<_Args>(__args)...))
     [inline], [static]"

Construct an object of type _Tp.

Parameters:
    __a An allocator.
    __p Pointer to memory of suitable size and alignment for Tp
    __args Constructor arguments.

Calls __a.construct(__p, std::forward<Args>(__args)...) if that expression is well-formed, otherwise uses placement-new to construct an object of type _Tp at location __p from the arguments __args...

Definition at line 400 of file bits/alloc_traits.h.

  template<typename _Alloc> static void std::allocator_traits< _Alloc >::deallocate (_Alloc & __a, pointer __p, size_type __n) [inline], [static]

Deallocate memory.

Parameters:
    __a An allocator.
    __p Pointer to the memory to deallocate.
    __n The number of objects space was allocated for.

Calls a.deallocate(p, n)

Definition at line 385 of file bits/alloc_traits.h.

Referenced by std::__allocated_ptr< _Alloc >::~__allocated_ptr().

  template<typename _Alloc> template<class _Tp > static void std::allocator_traits< _Alloc >::destroy (_Alloc & __a, _Tp * __p) [inline], [static]

Destroy an object of type _Tp.

Parameters:
    __a An allocator.
    __p Pointer to the object to destroy

Calls __a.destroy(__p) if that expression is well-formed, otherwise calls __p->~_Tp()

Definition at line 413 of file bits/alloc_traits.h.

  template<typename _Alloc> static size_type std::allocator_traits< _Alloc >::max_size (const _Alloc & __a) [inline], [static], [noexcept]

The maximum supported allocation size.

Parameters:
    __a An allocator.

Returns:
    __a.max_size() or numeric_limits<size_type>::max()

Returns __a.max_size() if that expression is well-formed, otherwise returns numeric_limits<size_type>::max()

Definition at line 424 of file bits/alloc_traits.h.

Referenced by std::forward_list< _Tp, _Alloc >::max_size().

  template<typename _Alloc> static _Alloc std::allocator_traits< _Alloc >::select_on_container_copy_construction (const _Alloc & __rhs) [inline], [static]

Obtain an allocator to use when copying a container.

Parameters:
    __rhs An allocator.

Returns:
    __rhs.select_on_container_copy_construction() or __rhs

Returns __rhs.select_on_container_copy_construction() if that expression is well-formed, otherwise returns __rhs

Definition at line 436 of file bits/alloc_traits.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.